# Assign the install directory

if [ -f "/usr/bin/zenity" ]
	then
		DIALOG=zenity
		INSTALL_DIR=`"$DIALOG" --entry --entry-text="/root/ralink" --title="Install Folder"`
		if [ -z "$INSTALL_DIR" ]
		then
			echo "no input!"
			exit 0
		fi

	
		# Assign the port number for Web Server
		PORT=`"$DIALOG" --entry --entry-text="8080" --title="Web UI port number"`
		if [ -z "$PORT" ]
		then
			echo "no input!"
			exit 0
		fi

else
	
	if [ -f "/usr/bin/kdialog" ]
	then
		DIALOG=kdialog
		INSTALL_DIR=`"$DIALOG" --inputbox "Install Folder" /root/ralink`
		if [ -z "$INSTALL_DIR" ]
		then
			echo "no input!"
			exit 0
		fi
	
		# Assign the port number for Web Server
		PORT=`"$DIALOG" --inputbox "Web UI port number" 8080`
		if [ -z "$PORT" ]
		then
			echo "no input!"
			exit 0
		fi

	else
		INSTALL_DIR=~/ralink
		PORT=8080
	fi
fi

Nvram_Driver=RT2860STA
export Nvram_Driver
export INSTALL_DIR
rm -rf $INSTALL_DIR


mkdir  -p $INSTALL_DIR
mkdir -p /etc/Wireless;
mkdir -p /etc/Wireless/RT2860STA/
mkdir -p $INSTALL_DIR/etc;
mkdir -p $INSTALL_DIR/etc/boa;

#rm -rf Link
#rm -rf points
#rm -rf to
#rm -rf \"

cp WebUI.tgz $INSTALL_DIR/
cp RT2860.tgz $INSTALL_DIR/
cp WPA_Supplicant.tgz $INSTALL_DIR/
cd $INSTALL_DIR/; tar xvfz WebUI.tgz;
cd $INSTALL_DIR/; tar xvfz RT2860.tgz;
cd $INSTALL_DIR/; tar xvfz WPA_Supplicant.tgz;

mv -f $INSTALL_DIR/RT2860/RT2860STA.dat /etc/Wireless/RT2860STA/

#make nvram
cd $INSTALL_DIR/WebUI/nvram; make; ./make_config_file

#make and insmod rt2860 driver
cd $INSTALL_DIR/RT2860; make clean; make ;

KernelVer=$(uname -r | cut -d. -f2)
if [ "$KernelVer" == "4" ]; then
        ModuleName=rt2860sta.o
else
        ModuleName=rt2860sta.ko
fi
ifconfig ra0 down;rmmod rt2860sta;
insmod os/linux/$ModuleName; ifconfig ra0 up;

#create boa.conf
cd $INSTALL_DIR/WebUI/; mv -f boa.conf $INSTALL_DIR/etc/boa/

#make wpa_supplicant
cd $INSTALL_DIR/WPA_Supplicant/; cp defconfig .config;  make;
cp -f wpa_supplicant $INSTALL_DIR/etc/boa/; mv -f wpa_cli $INSTALL_DIR/etc/boa/

#make Boa
killall boa;
cd $INSTALL_DIR/WebUI/boa/src; make clean; make;./boa -p $PORT -u $INSTALL_DIR/WebUI/httpd -c $INSTALL_DIR/etc/boa;



cd $INSTALL_DIR
echo "cd $INSTALL_DIR/RT2860;" > run.sh
echo "ifconfig ra0 down;" >>run.sh
echo "rmmod rt2860sta;" >>run.sh
echo "insmod os/linux/$ModuleName;" >>run.sh
echo "ifconfig ra0 up ;" >> run.sh

echo "killall boa;" >> run.sh
echo "cd $INSTALL_DIR/WebUI/boa/src;" >>run.sh
echo "./boa -p $PORT -u $INSTALL_DIR/WebUI/httpd -c $INSTALL_DIR/etc/boa;" >>run.sh


# start your web server
chmod 777 run.sh
test -e "/usr/bin/firefox" && echo "firefox 127.0.0.1:$PORT/Sta/index.html" >> run.sh && echo "You can execute $INSTALL_DIR/run.sh to start Browser next time."

echo ""
firefox 127.0.0.1:$PORT/Sta/index.html
if [ $? != 0 ]
then
	echo "You do not install firefox"
	test -e "/usr/bin/mozilla" && echo "mozilla 127.0.0.1:$PORT/Sta/index.html" >>run.sh && echo "You can execute $INSTALL_DIR/run.sh to start Browser next time."

	echo ""
	mozilla 127.0.0.1:$PORT/Sta/index.html
	if [ $? != 0 ]
	then
		echo "You do not install mozilla"
		test -e "/usr/bin/netscape" && echo "netscape 127.0.0.1:$PORT/Sta/index.html" >>run.sh && echo "You can execute $INSTALL_DIR/run.sh to start Browser next time."

		echo ""
		netscape 127.0.0.1:$PORT/Sta/index.html
		if [ $? != 0 ]
		then
			echo "You do not install netscape"
			echo "Try your self to bring up your browser on http://127.0.0.1:$PORT/Sta/index.html"
		fi
	fi
fi

