/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2005, Ralink Technology, Inc.
 *
 * This program is free software; you can redistribute it and/or modify  * 
 * it under the terms of the GNU General Public License as published by  * 
 * the Free Software Foundation; either version 2 of the License, or     * 
 * (at your option) any later version.                                   * 
 *                                                                       * 
 * This program is distributed in the hope that it will be useful,       * 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 * GNU General Public License for more details.                          * 
 *                                                                       * 
 * You should have received a copy of the GNU General Public License     * 
 * along with this program; if not, write to the                         * 
 * Free Software Foundation, Inc.,                                       * 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                       * 
 ************************************************************************/


/*
 *  methods.c - handlers for GET and POST methods
 */
 
#include "boa.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <netinet/in.h>    /* for sockaddr_in       */
#include <sys/times.h>
#include <syslog.h>
#include <sys/stat.h>

/* Maximum length of a filename - longer ones will be truncated */
#define FILENAMESZ 80
/* Buffer size for sending file */
#define FILEBUFSZ 4096

extern CGI_ENTRY cgi_entries[];
/* ssi_entries add by Dennis Lee */
extern SSI_ENTRY ssi_entries[];
void ssi_scan(char *filebuf,long count,FILE *out);
void handle_get_cgi(char *url, char *content);
void handle_post_cgi(char *url, char *content);
int check_post_cgi(char *url);

/* Mapping of file extensions to Content-type headers */
/* See also definition of FILETYPE in httpd.h */
FILETYPE types[] =
{
    {"htm", "text/html"},
    {"html", "text/html"},
    {"gif",  "image/gif"},
    {"jpg",  "image/jpeg"},
    {"shtml", "text/html"},
    {"asp", "text/html"},
    {"js", "text/javascript"},
    {"css", "text/css"},
// Final entry MUST have empty name and is the default type 
    {"",     "application/octet-stream"}
};

void handle_get(char *url, FILE *out);
const char *content_type(char *filename);
unsigned long find_length(FILE *fp);
void handle_post(char *url, char *content, FILE *out);
void handle_multipart(char *url, FILE *stream, FILE *out, int len, int len_boundary);
/* handle_ssi add by Dennis Lee*/
void handle_ssi(char *url,  FILE *out);
struct httpform *parseargs(char *input);
void unescape(char *string);
char *x_strtok(char *s, const char *delim);
void freeform( char *ptr);
/* add by albert 2000.11.2 */

#define MTD_BOOT "/dev/mtd1"
#define MTD_KERNEL "/dev/mtd2"
#define MTD_ROOT "/dev/mtd3"
#define MTD_CONFIG "/dev/mtd4"
#define MTD_NOTUSED "/dev/mtd5"
#define MTD_BOARDDATA "/dev/mtd6"
#define MTD_CALIBRATION "/dev/mtd7"

#define SIZE_BOOT 0x40000
#define SIZE_KERNEL 0x0c0000
#define SIZE_ROOT 0x270000
#define SIZE_CONFIG 0x80000
#define SIZE_NOTUSED 0xc000
#define SIZE_BOARDDATA 0x2000
#define SIZE_CALIBRATION 0x2000
#define SIZE_BUF 0x2000

int getFullFlash(FILE *out)
{
	int fd=0;
	int count=0, i=0;
	char buf[SIZE_BUF]="";
	
	//mtd1
	if ((fd = open(MTD_BOOT, O_RDONLY))<0){
		return -1;
	}
	for (i=0;i<(int)SIZE_BOOT/SIZE_BUF;i++) {
		memset(buf, 0, sizeof(char)*SIZE_BUF);
		count = read(fd, buf, sizeof(buf));
		fwrite(buf, 1, sizeof(buf), out);
	}
	close(fd);	
	//mtd2
	if ((fd = open(MTD_KERNEL, O_RDONLY))<0){
		return -1;
	}
	for (i=0;i<(int)SIZE_KERNEL/SIZE_BUF;i++) {
		memset(buf, 0, sizeof(char)*SIZE_BUF);
		count = read(fd, buf, sizeof(buf));
		fwrite(buf, 1, sizeof(buf), out);
	}
	close(fd);	
	//mtd3
	if ((fd = open(MTD_ROOT, O_RDONLY))<0){
		return -1;
	}
	for (i=0;i<(int)SIZE_ROOT/SIZE_BUF;i++) {
		memset(buf, 0, sizeof(char)*SIZE_BUF);
		count = read(fd, buf, sizeof(buf));
		fwrite(buf, 1, sizeof(buf), out);
	}
	close(fd);	
	//mtd4
	if ((fd = open(MTD_CONFIG, O_RDONLY))<0){
		return -1;
	}
	for (i=0;i<(int)SIZE_CONFIG/SIZE_BUF;i++) {
		memset(buf, 0, sizeof(char)*SIZE_BUF);
		count = read(fd, buf, sizeof(buf));
		fwrite(buf, 1, sizeof(buf), out);
	}
	close(fd);	
	//mtd5
	if ((fd = open(MTD_NOTUSED, O_RDONLY))<0){
		return -1;
	}
	for (i=0;i<(int)SIZE_NOTUSED/SIZE_BUF;i++) {
		memset(buf, 0, sizeof(char)*SIZE_BUF);
		count = read(fd, buf, sizeof(buf));
		fwrite(buf, 1, sizeof(buf), out);
	}
	close(fd);	
	//mtd6
	if ((fd = open(MTD_BOARDDATA, O_RDONLY))<0){
		return -1;
	}
	for (i=0;i<(int)SIZE_BOARDDATA/SIZE_BUF;i++) {
		memset(buf, 0, sizeof(char)*SIZE_BUF);
		count = read(fd, buf, sizeof(buf));
		fwrite(buf, 1, sizeof(buf), out);
	}
	close(fd);	
	//mtd7
	if ((fd = open(MTD_CALIBRATION, O_RDONLY))<0){
		return -1;
	}
	for (i=0;i<(int)SIZE_CALIBRATION/SIZE_BUF;i++) {
		memset(buf, 0, sizeof(char)*SIZE_BUF);
		count = read(fd, buf, sizeof(buf));
		fwrite(buf, 1, sizeof(buf), out);
	}
	close(fd);	
	
	return 0;
}

/* develop by Dennis Lee to enhance the Virita web server have
   ssi funcion
*/
void ssi_scan(char *filebuf,long count,FILE *out)
{
    int i;
    static int j=0;
    static int k=0;
    static int l=0;
    static int find_ssi=0;
    static char matchstr[MAXSSILEN]="<!--#include ssi=";
    char sendbuf[FILEBUFSZ];
    static char scanbuf[MAXSSILEN+FILEBUFSZ];
    static char ssi_function[MAXSSILEN];
    static int match_cnt=0;

    for(i=0;i<count;i++){
    	if((filebuf[i]==matchstr[match_cnt] )&& (find_ssi==0))
      	{
	    		scanbuf[match_cnt]=filebuf[i];
	    		match_cnt++;
	    		if(match_cnt==17)
	    		{
						find_ssi=1;
						if(j>0)
							fwrite(sendbuf,1,j,out);


						j=0;
	    		}
		}
		else
	    	if((find_ssi==1) && (filebuf[i] != '>'))
	    {

			if(filebuf[i] != '-'){
				if(filebuf[i] != ' '){
					ssi_function[l]=filebuf[i];
					l++;
				}
			}
	    }
		else
	    	if((find_ssi==1) && (filebuf[i]=='>'))
	    {
				handle_ssi(ssi_function,out);
				match_cnt=0;
				l=0;
				memset(ssi_function,'\0',MAXSSILEN);
				find_ssi=0;
	    }
		else
	    	if(match_cnt==0)
	    {
	        sendbuf[j]=filebuf[i];
			j++;
	    }
   		else
	 		if(match_cnt >0)
	    {
	        for(k=0;k <match_cnt;k++)
			{
		  	  sendbuf[j]=scanbuf[k];
		      j++;
			}
			sendbuf[j]=filebuf[i];/* un-match character */
			j++;
	        match_cnt=0;
	    }
    }
    if(j>0)
        fwrite(sendbuf,1,j,out);
    j=0;
}

/* Return a content-type string for the suffix of the supplied filename */

const char *content_type(char *filename)
{
    char *p;
    FILETYPE *f = types;

    /* p points to NULL at end of file name */
    p = &filename[strlen(filename)-1];
    /* Move p to point to first char after a '.' */
    while (*(p-1) != '\0' && *(p-1) != '.') p--;
    /* Find matching type */
    while (f->suffix[0] != '\0')
    {
        if (strcmp(f->suffix, p) == 0) break;
        f++;
    }
    return f->type;
}

/* Find the size of a file... */
unsigned long find_length(FILE *fp)
{
    unsigned long length = 0;

    /* Since we don't have fstat() on ATMOS, we seek to the end of the file,
     * find out where we are, and that tells us how long the file is.
     */

    fseek(fp, 0L, SEEK_END);
    length = ftell(fp);
    fseek(fp, 0L, SEEK_SET);

    return length;
}

/* will be called if it is a post or not found any file in www.* */
/* the system will go here to invoke the cgi */
/* by Dennis Lee */

void handle_post(char *url, char *content, FILE *out)
{
    CGI_ENTRY *p = cgi_entries;

    while (p->name[0] != '\0')
    {
        if (strcmp(p->name, url) == 0) break;
        p++;
    }
    if (p->handler != NULL)
    {
    	//cprintf("header--2\n");
    	/*
        fprintf(out, "HTTP/1.0 200 OK\r\n"
                "Cache-Control: no-cache\r\n"
                "Pragma: no-cache\r\n"
                "Expires: 0\r\n"
                "Content-type: text/html\r\n"
                "Connection: close\r\n\r\n");
        */
        p->handler(content, out);
    }
    else
    {
	fprintf(out, "HTTP/1.0 404 Not Found\r\n"
                "Content-type: text/html\r\n\r\n"
                "<html>\r\n"
                "<head><title>404 Not Found</title></head>\r\n"
                "<body><h1>404 Not Found</h1>\r\n"
                "<p>The resource you have requested is not available."
                "</p></body>\r\n"
                "</html>\r\n");

    }
}

void handle_multipart(char *url, FILE *stream, FILE *out, int len, int len_boundary)
{
    CGI_ENTRY *p = cgi_entries;
    char content[20];
    int rtn_value=0;
    
    while (p->name[0] != '\0')
    {
        if (strcmp(p->name, url) == 0) break;
        p++;
    }
    if (p->multi_handler != NULL)
    {
	rtn_value = p->multi_handler(stream, len, len_boundary);
	
    	memset(content, 0, sizeof(char)*20);
    	sprintf(content, "rtn_value=%d", rtn_value);

	fflush(out);
	//cprintf("header--3\n");
	/*
        fprintf(out, "HTTP/1.0 200 OK\r\n"
                "Cache-Control: no-cache\r\n"
                "Pragma: no-cache\r\n"
                "Expires: 0\r\n"
                "Content-type: text/html\r\n"
                "Connection: close\r\n\r\n");
        */
	p->handler(content, out);
    }
    else
    {
	fprintf(out, "HTTP/1.0 404 Not Found\r\n"
                "Content-type: text/html\r\n\r\n"
                "<html>\r\n"
                "<head><title>404 Not Found</title></head>\r\n"
                "<body><h1>404 Not Found</h1>\r\n"
                "<p>The resource you have requested is not available."
                "</p></body>\r\n"
                "</html>\r\n");
    }
}


/* add by Dennis Lee to process SSI */

void handle_ssi(char *url,  FILE *out)
{
    SSI_ENTRY *p = ssi_entries;

    char *ssi_arg, *ssi_end;

    ssi_arg = strchr(url, '(');
    ssi_end = strchr(url, ')');

	//modify by kathy, 2006-09-27
	if ((ssi_arg != NULL) && (ssi_end != NULL)) {
    	*ssi_arg = '\0';
    	ssi_arg += 1;
    	*ssi_end = '\0';
    }

    while (p->name[0] != '\0')
    {
        if (strcmp(p->name, url) == 0) break;
        p++;
    }
    if (p->handler != NULL)
    {
		p->handler(out, ssi_arg);
    }
    else
    {
        fprintf(out, "call_%s ",url);
    }
}
/* development by Dennis Lee */
/* this code reference InterNetch Web Port code */
/* develop by Dennis Lee */

struct httpform *parseargs(char *input)
{
    int i,nv_count=0;
    struct httpform *form=NULL;
    char *cp=NULL;
    cp=input;


    while (*cp >' ')
	if(*cp++ == '=')
		nv_count ++;

    if(nv_count==0)
    {
        form = (struct httpform *) malloc(sizeof(struct httpform));
		form->nv_ct=0;
		return form;
    }
    else
		form = (struct httpform *) malloc(sizeof(struct httpform) +
		((nv_count-1)*sizeof(struct name_val)));

    form->nv_ct=nv_count;
    cp=input;
    
    for(i=0;i<nv_count;i++)
    {    	
	form ->nameval[i].name=cp;
	cp= strchr(cp,'=');
	*cp=0;
	unescape(form->nameval[i].name);
	cp++;
	if(*cp <= ' ' || *cp == '&')
    	form->nameval[i].value=NULL;
	else
	{
    	form->nameval[i].value=cp;
    	cp = strchr (cp, '&');
	}
	if(cp)
	{
    	*cp=0;
		if (form->nameval[i].value) {
				unescape(form->nameval[i].value);
			}
    	cp++;
	}
    }
    
    //The last one
    if(form ->nameval[i-1].value)
    {
	cp=form->nameval[i-1].value;
        while (*cp > ' ')
	    cp++;
	*cp=0;
	unescape(form->nameval[i-1].value); //Add by Yating - 930210: need unescape the lase one
    }
    return form;
}

void freeform( char *ptr)
{
    free(ptr);
}

/* Given a www-form encoded string, restore the original: */
void unescape(char *string)
{
    char *src = string, *dest = string;
    int digit1, digit2;

    while (*src!='\0')
    {
        switch (*src)
        {
            case '+':
                *dest = ' ';
                break;
            case '%':
                src ++;
                if (*src >= '0' && *src <= '9') digit1 = *src - '0';
                else if (*src >= 'A' && *src <= 'F') digit1 = (*src - 'A') + 0xA;
                else if (*src >= 'a' && *src <= 'f') digit1 = (*src - 'a') + 0xA;
                else digit1 = 0;
                src ++;
                if (*src >= '0' && *src <= '9') digit2 = *src - '0';
                else if (*src >= 'A' && *src <= 'F') digit2 = (*src - 'A') + 0xA;
                else if (*src >= 'a' && *src <= 'f') digit2 = (*src - 'a') + 0xA;
                else digit2 = 0;
                *dest = (digit1 * 0x10) + digit2;
                break;
            default:
                *dest = *src;
        }
        src ++;
        dest ++;
    }
    *dest = '\0';
    return;
}

/* Like standard strtok, but handles empty tokens */
/* NB Only looks at one delimiter */
char *x_strtok(char *s, const char *delim)
{
    static char *start;
    char *p;
    if (s!=NULL) start=s;
    if (*start=='\0') return NULL;
    p=start;
    while (*start!=*delim && *start!='\0') start++;
    if (*start!='\0')
    {
        *start='\0';
        start++;
    }
    return p;
}

void handle_get_cgi(char *url, char *content) {

    CGI_ENTRY *p = cgi_entries;
    FILE      *out = NULL;

    while (p->name[0] != '\0') {
        if (strcmp(p->name, url) == 0) break;
        p++;
    }

    if (p->handler != NULL)
        p->handler(content, out);
}

void handle_post_cgi(char *url, char *content) {

    CGI_ENTRY *p = cgi_entries;
    FILE      *out = NULL;

    while (p->name[0] != '\0') {
        if (strcmp(p->name, url) == 0) break;
        p++;
    }

    if (p->handler != NULL)
        p->handler(content, out);
}

int check_post_cgi(char *url) {

    CGI_ENTRY *p = cgi_entries;

    while (p->name[0] != '\0') {
        if (strcmp(p->name, url) == 0) break;
        p++;
    }

    if (p->name[0] == '\0')
        return 1;

    return 0;
}
