/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2005, Ralink Technology, Inc.
 *
 * This program is free software; you can redistribute it and/or modify  * 
 * it under the terms of the GNU General Public License as published by  * 
 * the Free Software Foundation; either version 2 of the License, or     * 
 * (at your option) any later version.                                   * 
 *                                                                       * 
 * This program is distributed in the hope that it will be useful,       * 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 * GNU General Public License for more details.                          * 
 *                                                                       * 
 * You should have received a copy of the GNU General Public License     * 
 * along with this program; if not, write to the                         * 
 * Free Software Foundation, Inc.,                                       * 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                       * 
 ************************************************************************/

/* function definition*/
extern struct httpform *parseargs(char *input);
extern void freeform(char *ptr);
extern int nvram_set(char *name, char *value);
extern char *ram_get(char *name);
extern int log_split();
extern void unescape(char *string);
extern int fw_header_check(char *path, int *type);

//copy from rt61 Utility sha1.h
#define A_SHA_DIGEST_LEN 20

typedef struct 
{
    UINT	H[5];
    UINT   W[80];
    int             lenW;
    UINT   sizeHi,sizeLo;
} A_SHA_CTX;

typedef enum _ConnetedFromWhich
{
	Initial,
	ActivedFromProfile,
	ConnectedFromSiteSurvey,
	ConnectedFromWPS,
} ConnetedFromWhich;

void A_SHAInit(A_SHA_CTX *ctx);
void A_SHAUpdate(A_SHA_CTX *ctx, unsigned char *dataIn, int len);
void A_SHAFinal(A_SHA_CTX *ctx, unsigned char hashout[20]);


//== SSI ================================================================
void ssi_example(FILE *out, char *ssi_arg);
char *convSpecialCharToJs(char *str);
char *convSpecialCharToHtml(char *str);
char *convSpecialChar(char *str, char *convType);
void ssi_timesec(FILE *out, char *ssi_arg);

//*********************************************************//
/* 2004.12.21 add by arvin tai */
void ssi_getSystemUpTime(FILE *out, char *ssi_arg);
void ssi_getSystemName(FILE *out, char *ssi_arg);
void ssi_getWlanDriverVersion(FILE *out, char *ssi_arg);
void ssi_getWANIPInfo(FILE *out, char *ssi_arg);
void ssi_getWANDefaultGateway(FILE *out, char *ssi_arg);
void ssi_getWANPrimaryDNS(FILE *out, char *ssi_arg);
void ssi_getWANSecondaryDNS(FILE *out, char *ssi_arg);
void ssi_getLANIPInfo(FILE *out, char *ssi_arg);
void ssi_getDhcpsEnable(FILE *out, char *ssi_arg);
void ssi_getDhcpsStart(FILE *out, char *ssi_arg);
void ssi_getDhcpsEnd(FILE *out, char *ssi_arg);
void ssi_getDhcpsDnsrelay(FILE *out, char *ssi_arg);
void ssi_getDhcpsLeasetime(FILE *out, char *ssi_arg);
void ssi_dumpleases(FILE *out, char *ssi_arg);
void ssi_getStationAssociateList(FILE *out, char *ssi_arg);
void ssi_getWanConnectionMode(FILE *out, char *ssi_arg);
void ssi_getWlanCurrentWirelessMode(FILE *out, char *ssi_arg);
void ssi_getWlanCurrentSSIDNum(FILE *out, char *ssi_arg);
void ssi_getWlanCurrentSSID(FILE *out, char *ssi_arg);
void ssi_getWlanCurrentChannel(FILE *out, char *ssi_arg);
void ssi_getWlanCurrentBroadcastSSID(FILE *out, char *ssi_arg);
void ssi_getWlanCurrentSecurityMode(FILE *out, char *ssi_arg);
void ssi_getWlanCurrentMacAddress(FILE *out, char *ssi_arg);
void ssi_getWlanRadioEnable(FILE *out, char *ssi_arg);
void ssi_getWlanRadioMode(FILE *out, char *ssi_arg);
void ssi_getWlanSSID(FILE *out, char *ssi_arg);
void ssi_getWlanMainSSID(FILE *out, char *ssi_arg);
void ssi_getWlanMultiSSID1(FILE *out, char *ssi_arg);
void ssi_getWlanMultiSSID2(FILE *out, char *ssi_arg);
void ssi_getWlanMultiSSID3(FILE *out, char *ssi_arg);
void ssi_getWlanSSIDNum(FILE *out, char *ssi_arg);
void ssi_getWlanBroadcast(FILE *out, char *ssi_arg);
void ssi_getWlanChannel(FILE *out, char *ssi_arg);
void ssi_getWlan11aChannelList(FILE *out, char *ssi_arg);
void ssi_getWlan11bChannelList(FILE *out, char *ssi_arg);
void ssi_getWlan11gChannelList(FILE *out, char *ssi_arg);
void ssi_getWlanWDS(FILE *out, char *ssi_arg);
void ssi_getWlanWDSMAC(FILE *out, char *ssi_arg);
void ssi_triggerSiteSurvey(FILE *out, char *ssi_arg);
void ssid_getNetworkListNum(FILE *out, char *ssi_arg);
void ssid_getNetworkListSSID(FILE *out, char *ssi_arg);
void ssid_getNetworkListMAC(FILE *out, char *ssi_arg);
void ssid_getNetworkListAuth(FILE *out, char *ssi_arg);
void ssid_getNetworkListChannel(FILE *out, char *ssi_arg);
void ssid_getNetworkListWirelessMode(FILE *out, char *ssi_arg);
void ssid_getNetworkListRssi(FILE *out, char *ssi_arg);
void ssi_getWlanBasicRate(FILE *out, char *ssi_arg);
void ssi_getWlanBGProtection(FILE *out, char *ssi_arg);
void ssi_getWlanDataRate(FILE *out, char *ssi_arg);
void ssi_getWlanBeaconInterval(FILE *out, char *ssi_arg);
void ssi_getWlanDTIM(FILE *out, char *ssi_arg);
void ssi_getWlanFragmentThreshold(FILE *out, char *ssi_arg);
void ssi_getWlanRTSThreshold(FILE *out, char *ssi_arg);
void ssi_getWlanShortPreamble(FILE *out, char *ssi_arg);
void ssi_getWlanTxBurst(FILE *out, char *ssi_arg);
void ssi_getWlanPktAggregate(FILE *out, char *ssi_arg);
void ssi_getWlanIEEE80211h(FILE *out, char *ssi_arg);
void ssi_getWlanWmmCapable(FILE *out, char *ssi_arg);
void ssi_getWlanAPSDCapable(FILE *out, char *ssi_arg);
void ssi_getWlanDLSCapable(FILE *out, char *ssi_arg);
void ssi_getWlanAPAifsn(FILE *out, char *ssi_arg);
void ssi_getWlanAPCwmin(FILE *out, char *ssi_arg);
void ssi_getWlanAPCwmax(FILE *out, char *ssi_arg);
void ssi_getWlanAPTxop(FILE *out, char *ssi_arg);
void ssi_getWlanAPACM(FILE *out, char *ssi_arg);
void ssi_getWlanBSSAifsn(FILE *out, char *ssi_arg);
void ssi_getWlanBSSCwmin(FILE *out, char *ssi_arg);
void ssi_getWlanBSSCwmax(FILE *out, char *ssi_arg);
void ssi_getWlanBSSTxop(FILE *out, char *ssi_arg);
void ssi_getWlanBSSACM(FILE *out, char *ssi_arg);
void ssi_getWlanAckPolicy(FILE *out, char *ssi_arg);
void ssi_getWlanSSIDIndex(FILE *out, char *ssi_arg);
void ssi_getWlanSecurityMode(FILE *out, char *ssi_arg);
void ssi_getWlanIEEE8021x(FILE *out, char *ssi_arg);
void ssi_getWlanAuthMode(FILE *out, char *ssi_arg);
void ssi_getWlanEncrypType(FILE *out, char *ssi_arg);
void ssi_getWlanPreAuth(FILE *out, char *ssi_arg);
void ssi_getWlanPMKCachePeriod(FILE *out, char *ssi_arg);
void ssi_getWlanKeyType(FILE *out, char *ssi_arg);
void ssi_getWlanWepKey1(FILE *out, char *ssi_arg);
void ssi_getWlanWepKey2(FILE *out, char *ssi_arg);
void ssi_getWlanWepKey3(FILE *out, char *ssi_arg);
void ssi_getWlanWepKey4(FILE *out, char *ssi_arg);
void ssi_getWlanDefaultKey(FILE *out, char *ssi_arg);
void ssi_getWlanWPAPSK(FILE *out, char *ssi_arg);
void ssi_getWlanRekeyInterval(FILE *out, char *ssi_arg);
void ssi_getWlanRadiusServer1(FILE *out, char *ssi_arg);
void ssi_getWlanRadiusPort1(FILE *out, char *ssi_arg);
void ssi_getWlanRadiusKey1(FILE *out, char *ssi_arg);
void ssi_getWlanRadiusSessionTimeOut(FILE *out, char *ssi_arg);
void ssi_getWlanRadiusIdleTimeOut(FILE *out, char *ssi_arg);
void ssi_getWlanAcctServer(FILE *out, char *ssi_arg);
void ssi_getWlanAcctPort(FILE *out, char *ssi_arg);
void ssi_getWlanAcctKey(FILE *out, char *ssi_arg);
void ssi_getWlanAccessPolicy(FILE *out, char *ssi_arg);
void ssi_getWlanAccessControlList(FILE *out, char *ssi_arg);
void ssi_getWlanUAMIPPool(FILE *out, char *ssi_arg);
void ssi_getWlanUAMDNS1(FILE *out, char *ssi_arg);
void ssi_getWlanUAMDNS2(FILE *out, char *ssi_arg);
void ssi_getWlanUAMLeaseTime(FILE *out, char *ssi_arg);
void ssi_getWlanUAMRadius1(FILE *out, char *ssi_arg);
void ssi_getWlanUAMRadius2(FILE *out, char *ssi_arg);
void ssi_getWlanUAMRadiusSecret(FILE *out, char *ssi_arg);
void ssi_getWlanUAMURL(FILE *out, char *ssi_arg);
void ssi_getWlanUAMRadiusNASID(FILE *out, char *ssi_arg);
void ssi_getWlanVlanEnable(FILE *out, char *ssi_arg);
void ssi_getWlanVlanIndex(FILE *out, char *ssi_arg);
void ssi_getWlanVlanName(FILE *out, char *ssi_arg);
void ssi_getWlanVlanId(FILE *out, char *ssi_arg);
void ssi_getWlanVlanPriority(FILE *out, char *ssi_arg);
void ssi_getWlanCountryCode(FILE *out, char *ssi_arg);
void ssi_getSystemPassword(FILE *out, char *ssi_arg);
void ssi_getSystemTimeMethod(FILE *out, char *ssi_arg);
void ssi_getSystemTime(FILE *out, char *ssi_arg);
void ssi_getSystemNTPServer(FILE *out, char *ssi_arg);
void ssi_getSystemNTPInterval(FILE *out, char *ssi_arg);
void ssi_getSystemTimeZone(FILE *out, char *ssi_arg);
#ifdef RALINK_ATE
void ssi_getATEActionMode(FILE *out, char *ssi_arg);
void ssi_getATEActionStart(FILE *out, char *ssi_arg);
void ssi_getATERefreshTime(FILE *out, char *ssi_arg);
void ssi_getATEDA(FILE *out, char *ssi_arg);
void ssi_getATESA(FILE *out, char *ssi_arg);
void ssi_getATEBssid(FILE *out, char *ssi_arg);
void ssi_getATETxPower(FILE *out, char *ssi_arg);
void ssi_getATEChannel(FILE *out, char *ssi_arg);
void ssi_getATETxFreqOffset(FILE *out, char *ssi_arg);
void ssi_getATETxLength(FILE *out, char *ssi_arg);
void ssi_getATETxCount(FILE *out, char *ssi_arg);
void ssi_getATETxRate(FILE *out, char *ssi_arg);
void ssi_getEEPROMReadWrite(FILE *out, char *ssi_arg);
void ssi_getEEPROMOffset(FILE *out, char *ssi_arg);
void ssi_getEEPROMValue(FILE *out, char *ssi_arg);
void ssi_getMACReadWrite(FILE *out, char *ssi_arg);
void ssi_getMACOffset(FILE *out, char *ssi_arg);
void ssi_getMACValue(FILE *out, char *ssi_arg);
void ssi_getBBPReadWrite(FILE *out, char *ssi_arg);
void ssi_getBBPOffset(FILE *out, char *ssi_arg);
void ssi_getBBPValue(FILE *out, char *ssi_arg);
#endif
void ssi_getWlanStatistics(FILE *out, char *ssi_arg);
void ssi_redirectSetupPage(FILE *out, char *ssi_arg);
void ssi_rebootAP(FILE *out, char *ssi_arg);
//kathy , for 11n
void ssi_get11nMode(FILE *out, char *ssi_arg);
void ssi_get11nBandWidth(FILE *out, char *ssi_arg);
void ssi_get11nGI(FILE *out, char *ssi_arg);
void ssi_get11nSTBC(FILE *out, char *ssi_arg);
void ssi_get11nMCS(FILE *out, char *ssi_arg);
//void ssi_get11nTxRate(FILE *out, char *ssi_arg);
//kathy, for sta, 2006_0926
void ssi_getStaProfile(FILE *out, char *ssi_arg);
void ssi_getStaProfileName(FILE *out, char *ssi_arg);
void ssi_getStaAdhocChannel(FILE *out, char *ssi_arg);
void ssi_getStaAllProfileName(FILE *out, char *ssi_arg);
void ssi_getStaNewProfileName(FILE *out, char *ssi_arg);
void ssi_getStaSSID(FILE *out, char *ssi_arg);
void ssi_getStaNetworkType(FILE *out, char *ssi_arg);
void ssi_getStaPowerSavingMode(FILE *out, char *ssi_arg);
void ssi_getStaRTSCheck(FILE *out, char *ssi_arg);
void ssi_getStaFragmentCheck(FILE *out, char *ssi_arg);
void ssi_getStaRTS(FILE *out, char *ssi_arg);
void ssi_getStaFragment(FILE *out, char *ssi_arg);
//void ssi_getStaAdhocMode(FILE *out, char *ssi_arg);
void ssi_getStaChannel(FILE *out, char *ssi_arg);
void ssi_getStaPremableType(FILE *out, char *ssi_arg);
void ssi_getStaAuth(FILE *out, char *ssi_arg);
void ssi_getStaEncryp(FILE *out, char *ssi_arg);
void ssi_getStaKey1(FILE *out, char *ssi_arg);
void ssi_getStaKey2(FILE *out, char *ssi_arg);
void ssi_getStaKey3(FILE *out, char *ssi_arg);
void ssi_getStaKey4(FILE *out, char *ssi_arg);
void ssi_getStaKey1Type(FILE *out, char *ssi_arg);
void ssi_getStaKey2Type(FILE *out, char *ssi_arg);
void ssi_getStaKey3Type(FILE *out, char *ssi_arg);
void ssi_getStaKey4Type(FILE *out, char *ssi_arg);
void ssi_getStaKey1Length(FILE *out, char *ssi_arg);
void ssi_getStaKey2Length(FILE *out, char *ssi_arg);
void ssi_getStaKey3Length(FILE *out, char *ssi_arg);
void ssi_getStaKey4Length(FILE *out, char *ssi_arg);

void ssi_getStaKeyDefaultID(FILE *out, char *ssi_arg);
void ssi_getStaWPAPSK(FILE *out, char *ssi_arg);
//site survey
void ssi_getStaConnectionSSID(FILE *out, char *ssi_arg);
void ssi_getStaBSSIDScanList(FILE *out, char *ssi_arg);
void ssi_refreshStaSiteSurvey(FILE *out, char *ssi_arg);
void ssi_refreshStaProfile(FILE *out, char *ssi_arg);
void ssi_getStaSupportAMode(FILE *out, char *ssi_arg);
void ssi_getStaWirelessMode(FILE *out, char *ssi_arg);
void ssi_getStaCountryRegionA(FILE *out, char *ssi_arg);
void ssi_getStaCountryRegionBG(FILE *out, char *ssi_arg);
void ssi_getStaBGProtection(FILE *out, char *ssi_arg);
void ssi_getStaTxRate(FILE *out, char *ssi_arg);
void ssi_getStaTxBurst(FILE *out, char *ssi_arg);
void ssi_getStaShortSlotTime(FILE *out, char *ssi_arg);
void ssi_getStaRadioStatus(FILE *out, char *ssi_arg);
//Statistics
void ssi_getStaStatisicsTx(FILE *out, char *ssi_arg);
void ssi_getStaStatisicsRxOk(FILE *out, char *ssi_arg);
void ssi_getStaStatisicsRxNoBuf(FILE *out, char *ssi_arg);
void ssi_getStaStatisicsRxCRCError(FILE *out, char *ssi_arg);
void ssi_getStaStatisicsRxDuplication(FILE *out, char *ssi_arg);
//Link Status
void ssi_getStaLinkStatus(FILE *out, char *ssi_arg);
void ssi_getStaConnectionStatusForLinkStatus(FILE *out, char *ssi_arg);
void ssi_getStaExtraInfo(FILE *out, char *ssi_arg);
void ssi_getStaLinkChannel(FILE *out, char *ssi_arg);
void ssi_getStaLinkTxRate(FILE *out, char *ssi_arg);
void ssi_getStaLinkRxRate(FILE *out, char *ssi_arg);
void ssi_getStaTxThroughput(FILE *out, char *ssi_arg);
void ssi_getStaRxThroughput(FILE *out, char *ssi_arg);
void ssi_getStaLinkQuality(FILE *out, char *ssi_arg);
void ssi_getStaSignalStrength(FILE *out, char *ssi_arg);
void ssi_getStaSignalStrength_1(FILE *out, char *ssi_arg);
#ifdef PHY_N_SUPPORT
void ssi_getStaSignalStrength_2(FILE *out, char *ssi_arg);
#endif
void ssi_getStadBmisCheck(FILE *out, char *ssi_arg);
#ifdef PHY_N_SUPPORT
void ssi_getStaHT(FILE *out, char *ssi_arg);
void ssi_getStaSNR0(FILE *out, char *ssi_arg);
void ssi_getStaSNR1(FILE *out, char *ssi_arg);
#endif
//about
void ssi_getStaDriverVersion(FILE *out, char *ssi_arg);
void ssi_getStaUIVersion(FILE *out, char *ssi_arg);
void ssi_getStaEEPROMVersion(FILE *out, char *ssi_arg);
void ssi_getStaFirmwareVersion(FILE *out, char *ssi_arg);
void ssi_getStaMacAddress(FILE *out, char *ssi_arg);
#ifdef QOS_DLS_SUPPORT
void ssi_getStaWMMEnable(FILE *out, char *ssi_arg);
void ssi_getStaAPSDEnable(FILE *out, char *ssi_arg);
void ssi_getStaDLSEnable(FILE *out, char *ssi_arg);
void ssi_getStaPSACBK(FILE *out, char *ssi_arg);
void ssi_getStaPSACBE(FILE *out, char *ssi_arg);
void ssi_getStaPSACVO(FILE *out, char *ssi_arg);
void ssi_getStaPSACVI(FILE *out, char *ssi_arg);
void ssi_getStaDlsList(FILE *out, char *ssi_arg);
#endif
#ifdef STA_EXTEND_SUPPORT
void ssi_getStaBAEnable(FILE *out, char *ssi_arg);
void ssi_getStaBAAuto(FILE *out, char *ssi_arg);
void ssi_getStaBADesity(FILE *out, char *ssi_arg);
void ssi_getStaOriBATable(FILE *out, char *ssi_arg);
void ssi_getStaRecBATable(FILE *out, char *ssi_arg);
void ssi_getStaConnectedBSSID(FILE *out, char *ssi_arg);
void ssi_refreshSta11nConfiguration(FILE *out, char *ssi_arg);
void ssi_setRefreshSta11nConfiguration(FILE *out, char *ssi_arg);
#endif
#ifdef PHY_N_SUPPORT
void ssi_getHTMode(FILE *out, char *ssi_arg);
void ssi_getHTBandWidth(FILE *out, char *ssi_arg);
void ssi_getHTGI(FILE *out, char *ssi_arg);
void ssi_getHTMCS(FILE *out, char *ssi_arg);
#endif
//802.1x
void ssi_getSta8021xKeyMgmt(FILE *out, char *ssi_arg);
void ssi_getSta8021xEAP(FILE *out, char *ssi_arg);
void ssi_getSta8021xIdentity(FILE *out, char *ssi_arg);
void ssi_getSta8021xCACert(FILE *out, char *ssi_arg);
void ssi_getSta8021xClientCert(FILE *out, char *ssi_arg);
void ssi_getSta8021xPrivateKey(FILE *out, char *ssi_arg);
void ssi_getSta8021xPrivateKeyPassword(FILE *out, char *ssi_arg);
void ssi_getSta8021xPassword(FILE *out, char *ssi_arg);
void ssi_getSta8021xTunnel(FILE *out, char *ssi_arg);

void ssi_getStaDeviceCard(FILE *out, char *ssi_arg);

void ssi_getStaDeviceName(FILE *out, char *ssi_arg);
void ssi_getStaDeviceCardIndex(FILE *out, char *ssi_arg);
void ssi_getStaDHCPFlag(FILE *out, char *ssi_arg);
void ssi_getStaIP(FILE *out, char *ssi_arg);
void ssi_getStaNetMask(FILE *out, char *ssi_arg);
void ssi_getStaInterfaceInfo(FILE *out, char *ssi_arg);
void ssi_getStaCloseWindowsFlag(FILE * out, char * ssi_arg);

// for framework
void ssi_getStaSupportExtChannel(FILE *out, char *ssi_arg);
void ssi_getStaCountryCode(FILE *out, char *ssi_arg);
void ssi_getStaChannelGeography(FILE *out, char *ssi_arg);
void ssi_getStaChannelList(FILE *out, char *ssi_arg);
void ssi_getStaInfraMode(FILE *out, char *ssi_arg);



//== CGI ================================================================
void cgi_example(char *data, FILE *out);
void cgi_apply(char *data, FILE *out);
void cgi_wan_connection_type_apply(char *data, FILE *out);
void cgi_lan_apply(char *data, FILE *out);
void cgi_wan_mac_apply(char *data, FILE *out);
void cgi_wireless_basic_apply(char *data, FILE *out);
void cgi_wireless_advanced_apply(char *data, FILE *out);
void cgi_wireless_security_apply(char *data, FILE *out);
void cgi_acl_apply(char *data, FILE *out);
void cgi_wmm_apply(char *data, FILE *out);
void cgi_vlan_apply(char *data, FILE *out);
void cgi_utilities_system_settings_apply(char *data, FILE *out);
void cgi_utilities_restart_default_apply(char *data, FILE *out);
#ifdef RALINK_ATE
void cgi_ate_txrx_apply(char *data, FILE *out);
void cgi_ate_eeprom_apply(char *data, FILE *out);
void cgi_ate_mac_apply(char *data, FILE *out);
void cgi_ate_bbp_apply(char *data, FILE *out);
#endif
//kathy , for sta
void cgi_sta_profile_apply(char *data, FILE *out);
void cgi_sta_add_profile_apply(char *data, FILE *out);
void cgi_sta_edit_profile_apply(char *data, FILE *out);
void cgi_sta_site_survey_connection_apply(char *data, FILE *out);
void cgi_sta_n_mode_disallow_tkip_apply(char *data, FILE *out);
void cgi_sta_advance_apply(char *data, FILE *out);
void cgi_sta_statisics_apply(char *data, FILE *out);
void cgi_sta_link_status_apply(char *data, FILE *out);
void cgi_sta_sys_config_apply(char *data, FILE *out);
void cgi_sta_if_info_apply(char * data, FILE * out);


// rt2860 sta, kathy
#ifdef QOS_DLS_SUPPORT
void cgi_sta_qos_apply(char *data, FILE *out);
#endif
#ifdef STA_EXTEND_SUPPORT
void cgi_sta_11n_configuration_apply(char *data, FILE *out);
void cgi_sta_ampdu_org_add_apply(char *data, FILE *out);
void cgi_sta_ampdu_org_del_apply(char *data, FILE *out);
#endif



//Multiple card , kathy, 2008-0108
void cgi_sta_menu_apply(char * data, FILE * out);

void exec_WPASupplicant(char* ssid, NDIS_802_11_MAC_ADDRESS bssid, NDIS_802_11_WEP_STATUS encryp, NDIS_802_11_AUTHENTICATION_MODE auth, RT_WPA_SUPPLICANT_KEY_MGMT keymgmt, int keyidx, char* wepkey);

void conf_WPASupplicant(char* ssid, NDIS_802_11_MAC_ADDRESS bssid, RT_WPA_SUPPLICANT_KEY_MGMT keymgmt, RT_WPA_SUPPLICANT_EAP eap, char* identity, char* password, char* cacert, char* clientcert, char* privatekey, char* privatekeypassword, char* wepkey, int keyidx, NDIS_802_11_WEP_STATUS encryp, RT_WPA_SUPPLICANT_TUNNEL tunnel, NDIS_802_11_AUTHENTICATION_MODE auth);
void sta_connection(int tmp_networktype, int tmp_auth, int tmp_encry, int tmp_defaultkeyid, PNDIS_802_11_SSID pSsid, NDIS_802_11_MAC_ADDRESS Bssid, char *tmp_wpapsk, char *tmp_key1, char *tmp_key2, char *tmp_key3, char *tmp_key4, RT_802_11_PREAMBLE tmp_preamtype, int tmp_rtscheck, NDIS_802_11_RTS_THRESHOLD tmp_rts, int tmp_fragmentcheck, NDIS_802_11_FRAGMENTATION_THRESHOLD tmp_fragment, NDIS_802_11_POWER_MODE tmp_psmode, int tmp_channel);
void sleepForConnStatus();

//
void process_ssid_map_security(char *pos);
void process_security_mapping(char *var_name, char *pos);
void process_security_item_submit(char *var_name, char *value, int security_idx);
int  init_mbss_value(int, char*);
int  save_mbss_value_to_flash(int);
int  reloadWirelessModule();
void dhcpc_dumpdns();
void hex_dump(char *str, unsigned char *pSrcBufVA, unsigned int SrcBufLen);

//-------------------------------------------------------------------------

/* List of "script" names and handlers */
/* See also definition of CGI_ENTRY in httpd.h */
CGI_ENTRY cgi_entries[] =
{
    {"cgi_example", cgi_example, NULL},
    {"/wan_connection_type.html", cgi_wan_connection_type_apply, NULL},
    {"/lan.html", cgi_lan_apply, NULL},
    {"/wan_mac.html", cgi_wan_mac_apply, NULL},
    {"/wireless_basic.html", cgi_wireless_basic_apply, NULL},
    {"/wireless_advanced.html", cgi_wireless_advanced_apply, NULL},
    {"/wireless_security.html", cgi_wireless_security_apply, NULL},
    {"/acl.html", cgi_acl_apply, NULL},
    {"/wmm.html", cgi_wmm_apply, NULL},
    {"/vlan.html", cgi_vlan_apply, NULL},
    {"/utilities_system_settings.html", cgi_utilities_system_settings_apply, NULL},
    {"/utilities_restart_default.html", cgi_utilities_restart_default_apply, NULL},
#ifdef RALINK_ATE
    {"/ate_txrx.html", cgi_ate_txrx_apply, NULL},
    {"/ate_eeprom.html", cgi_ate_eeprom_apply, NULL},
    {"/ate_mac.html", cgi_ate_mac_apply, NULL},
    {"/ate_bbp.html", cgi_ate_bbp_apply, NULL},
#endif    
    {"/Sta/sta_profile.html", cgi_sta_profile_apply, NULL},
    {"/Sta/add_profile_page.html", cgi_sta_add_profile_apply, NULL},
    {"/Sta/edit_profile_page.html", cgi_sta_edit_profile_apply, NULL},
    {"/Sta/sta_site_survey_connection.html", cgi_sta_site_survey_connection_apply, NULL},
    {"/Sta/sta_n_mode_disallow_tkip.html", cgi_sta_n_mode_disallow_tkip_apply, NULL},
    {"/Sta/sta_advance.html", cgi_sta_advance_apply, NULL},
    {"/Sta/sta_statistics.html", cgi_sta_statisics_apply, NULL},
    {"/Sta/sta_link_status.html", cgi_sta_link_status_apply, NULL},
	{"/Sta/sta_sys_config.html", cgi_sta_sys_config_apply, NULL}, //2008_0212, kathy, for dhcp
	{"/Sta/sta_if_info.html", cgi_sta_if_info_apply, NULL}, //2008_0523, kathy
#ifdef QOS_DLS_SUPPORT    
	{"/Sta/sta_qos.html", cgi_sta_qos_apply, NULL},
#endif
#ifdef STA_EXTEND_SUPPORT
	{"/Sta/sta_11n_configuration.html", cgi_sta_11n_configuration_apply, NULL},
	{"/Sta/sta_ampdu_org_add.html", cgi_sta_ampdu_org_add_apply, NULL},
	{"/Sta/sta_ampdu_org_del.html", cgi_sta_ampdu_org_del_apply, NULL},
#endif




	{"/Sta/menu.html", cgi_sta_menu_apply, NULL},
    /* Array MUST be terminated by empty entry */
    {"", cgi_apply, NULL}
};

SSI_ENTRY ssi_entries[] =
{
    {"ssi_example", ssi_example},
    {"getSystemUpTime", ssi_getSystemUpTime},
    {"getWlanDriverVersion", ssi_getWlanDriverVersion},
    {"getSystemName", ssi_getSystemName},
    {"timesec", ssi_timesec},
    {"getDhcpTableList", ssi_dumpleases},
    {"getStationAssociateList", ssi_getStationAssociateList},
    {"getWanConnectionMode", ssi_getWanConnectionMode},
    {"getWANIPInfo", ssi_getWANIPInfo},
    {"getWANDefaultGateway", ssi_getWANDefaultGateway},
    {"getWANPrimaryDNS", ssi_getWANPrimaryDNS},
    {"getWANSecondaryDNS", ssi_getWANSecondaryDNS},
    {"getLANIPInfo", ssi_getLANIPInfo},
    {"getDhcpsEnable", ssi_getDhcpsEnable},
    {"getDhcpsStart", ssi_getDhcpsStart},
    {"getDhcpsEnd", ssi_getDhcpsEnd},
    {"getDhcpsDnsrelay", ssi_getDhcpsDnsrelay},
    {"getDhcpsLeasetime", ssi_getDhcpsLeasetime},
    {"getWlanCurrentWirelessMode", ssi_getWlanCurrentWirelessMode},
    {"getWlanCurrentSSIDNum", ssi_getWlanCurrentSSIDNum},
    {"getWlanCurrentSSID", ssi_getWlanCurrentSSID},
    {"getWlanCurrentChannel", ssi_getWlanCurrentChannel},
    {"getWlanCurrentBroadcastSSID", ssi_getWlanCurrentBroadcastSSID},
    {"getWlanCurrentSecurityMode", ssi_getWlanCurrentSecurityMode},
    {"getWlanCurrentMacAddress", ssi_getWlanCurrentMacAddress},
    {"getWlanRadioEnable", ssi_getWlanRadioEnable},
    {"getWlanRadioMode", ssi_getWlanRadioMode},
    {"getWlanSSID", ssi_getWlanSSID},
    {"getWlanMainSSID", ssi_getWlanMainSSID},
    {"getWlanMultiSSID1", ssi_getWlanMultiSSID1},
    {"getWlanMultiSSID2", ssi_getWlanMultiSSID2},
    {"getWlanMultiSSID3", ssi_getWlanMultiSSID3},
    {"getWlanSSIDNum", ssi_getWlanSSIDNum},
    {"getWlanBroadcast", ssi_getWlanBroadcast},
    {"getWlanChannel", ssi_getWlanChannel},
    {"getWlan11aChannelList", ssi_getWlan11aChannelList},
    {"getWlan11bChannelList", ssi_getWlan11bChannelList},
    {"getWlan11gChannelList", ssi_getWlan11gChannelList},
    {"getWlanWDS", ssi_getWlanWDS},
    {"getWlanWDSMAC", ssi_getWlanWDSMAC},
    {"triggerSiteSurvey", ssi_triggerSiteSurvey},
    {"getNetworkListNum", ssid_getNetworkListNum},
    {"getNetworkListSSID", ssid_getNetworkListSSID},
    {"getNetworkListMAC", ssid_getNetworkListMAC},
    {"getNetworkListAuth", ssid_getNetworkListAuth},
    {"getNetworkListChannel", ssid_getNetworkListChannel},
    {"getNetworkListWirelessMode", ssid_getNetworkListWirelessMode},
    {"getNetworkListRssi", ssid_getNetworkListRssi},
    {"getWlanBasicRate", ssi_getWlanBasicRate},
    {"getWlanBGProtection", ssi_getWlanBGProtection},
    {"getWlanDataRate", ssi_getWlanDataRate},
    {"getWlanBeaconInterval", ssi_getWlanBeaconInterval},
    {"getWlanDTIM", ssi_getWlanDTIM},
    {"getWlanFragmentThreshold", ssi_getWlanFragmentThreshold},
    {"getWlanRTSThreshold", ssi_getWlanRTSThreshold},
    {"getWlanShortPreamble", ssi_getWlanShortPreamble},
    {"getWlanTxBurst", ssi_getWlanTxBurst},
    {"getWlanPktAggregate", ssi_getWlanPktAggregate},
    {"getWlanIEEE80211h", ssi_getWlanIEEE80211h},
    {"getWlanWmmCapable", ssi_getWlanWmmCapable},
    {"getWlanAPSDCapable", ssi_getWlanAPSDCapable},
    {"getWlanDLSCapable", ssi_getWlanDLSCapable},
    {"getWlanAPAifsn", ssi_getWlanAPAifsn},
    {"getWlanAPCwmin", ssi_getWlanAPCwmin},
    {"getWlanAPCwmax", ssi_getWlanAPCwmax},
    {"getWlanAPTxop", ssi_getWlanAPTxop},
    {"getWlanAPACM", ssi_getWlanAPACM},
    {"getWlanBSSAifsn", ssi_getWlanBSSAifsn},
    {"getWlanBSSCwmin", ssi_getWlanBSSCwmin},
    {"getWlanBSSCwmax", ssi_getWlanBSSCwmax},
    {"getWlanBSSTxop", ssi_getWlanBSSTxop},
    {"getWlanBSSACM", ssi_getWlanBSSACM},
    {"getWlanAckPolicy", ssi_getWlanAckPolicy},
    {"getWlanSSIDIndex", ssi_getWlanSSIDIndex},
    {"getWlanSecurityMode", ssi_getWlanSecurityMode},
    {"getWlanIEEE8021x", ssi_getWlanIEEE8021x},
    {"getWlanAuthMode", ssi_getWlanAuthMode},
    {"getWlanEncrypType", ssi_getWlanEncrypType},
    {"getWlanPreAuth", ssi_getWlanPreAuth},
    {"getWlanPMKCachePeriod", ssi_getWlanPMKCachePeriod},
    {"getWlanKeyType", ssi_getWlanKeyType},
    {"getWlanWepKey1", ssi_getWlanWepKey1},
    {"getWlanWepKey2", ssi_getWlanWepKey2},
    {"getWlanWepKey3", ssi_getWlanWepKey3},
    {"getWlanWepKey4", ssi_getWlanWepKey4},
    {"getWlanDefaultKey", ssi_getWlanDefaultKey},
    {"getWlanWPAPSK", ssi_getWlanWPAPSK},
    {"getWlanRekeyInterval", ssi_getWlanRekeyInterval},
    {"getWlanRadiusServer1", ssi_getWlanRadiusServer1},
    {"getWlanRadiusPort1", ssi_getWlanRadiusPort1},
    {"getWlanRadiusKey1", ssi_getWlanRadiusKey1},
    {"getWlanRadiusSessionTimeOut", ssi_getWlanRadiusSessionTimeOut},
    {"getWlanRadiusIdleTimeOut", ssi_getWlanRadiusIdleTimeOut},
    {"getWlanAcctServer", ssi_getWlanAcctServer},
    {"getWlanAcctPort", ssi_getWlanAcctPort},
    {"getWlanAcctKey", ssi_getWlanAcctKey},
    {"getWlanAccessPolicy", ssi_getWlanAccessPolicy},
    {"getWlanAccessControlList", ssi_getWlanAccessControlList},
    {"getWlanUAMIPPool", ssi_getWlanUAMIPPool},
    {"getWlanUAMDNS1", ssi_getWlanUAMDNS1},
    {"getWlanUAMDNS2", ssi_getWlanUAMDNS2},
    {"getWlanUAMLeaseTime", ssi_getWlanUAMLeaseTime},
    {"getWlanUAMRadius1", ssi_getWlanUAMRadius1},
    {"getWlanUAMRadius2", ssi_getWlanUAMRadius2},
    {"getWlanUAMRadiusSecret", ssi_getWlanUAMRadiusSecret},
    {"getWlanUAMURL", ssi_getWlanUAMURL},
    {"getWlanUAMRadiusNASID", ssi_getWlanUAMRadiusNASID},
    {"getWlanVlanEnable", ssi_getWlanVlanEnable},
    {"getWlanVlanIndex", ssi_getWlanVlanIndex},
    {"getWlanVlanName", ssi_getWlanVlanName},
    {"getWlanVlanId", ssi_getWlanVlanId},
    {"getWlanVlanPriority", ssi_getWlanVlanPriority},
    {"getSystemPassword", ssi_getSystemPassword},
    {"getWlanCountryCode", ssi_getWlanCountryCode},
    {"getSystemTimeMethod", ssi_getSystemTimeMethod},
    {"getSystemTime", ssi_getSystemTime},
    {"getSystemNTPServer", ssi_getSystemNTPServer},
    {"getSystemNTPInterval", ssi_getSystemNTPInterval},
    {"getSystemTimeZone", ssi_getSystemTimeZone},
#ifdef RALINK_ATE
    {"getATEActionMode", ssi_getATEActionMode},
    {"getATEActionStart", ssi_getATEActionStart},
    {"getATERefreshTime", ssi_getATERefreshTime},
    {"getATEDA", ssi_getATEDA},
    {"getATESA", ssi_getATESA},
    {"getATEBssid", ssi_getATEBssid},
    {"getATETxPower", ssi_getATETxPower},
    {"getATEChannel", ssi_getATEChannel},
    {"getATETxFreqOffset", ssi_getATETxFreqOffset},
    {"getATETxLength", ssi_getATETxLength},
    {"getATETxCount", ssi_getATETxCount},
    {"getATETxRate", ssi_getATETxRate},
    {"getEEPROMReadWrite", ssi_getEEPROMReadWrite},
    {"getEEPROMOffset", ssi_getEEPROMOffset},
    {"getEEPROMValue", ssi_getEEPROMValue},
    {"getMACReadWrite", ssi_getMACReadWrite},
    {"getMACOffset", ssi_getMACOffset},
    {"getMACValue", ssi_getMACValue},
    {"getBBPReadWrite", ssi_getBBPReadWrite},
    {"getBBPOffset", ssi_getBBPOffset},
    {"getBBPValue", ssi_getBBPValue},
#endif    
    {"getWlanStatistics", ssi_getWlanStatistics},
    {"redirectSetupPage", ssi_redirectSetupPage},
    {"rebootAP", ssi_rebootAP},
	//add by kathy , for 11n
	{"get11nMode", ssi_get11nMode},
	{"get11nBandWidth", ssi_get11nBandWidth},
	{"get11nGI", ssi_get11nGI},
	{"get11nSTBC", ssi_get11nSTBC},
	{"get11nMCS", ssi_get11nMCS},
	//{"get11nTxRate", ssi_get11nTxRate},
	// for sta, get profile
	{"getStaProfile", ssi_getStaProfile},
   	{"getStaProfileName", ssi_getStaProfileName},
	{"getStaAdhocChannel", ssi_getStaAdhocChannel},
	{"getStaAllProfileName", ssi_getStaAllProfileName},
	{"getStaNewProfileName", ssi_getStaNewProfileName},
   	{"getStaSSID", ssi_getStaSSID},
   	{"getStaNetworkType", ssi_getStaNetworkType},
   	{"getStaPowerSavingMode", ssi_getStaPowerSavingMode},
   	{"getStaRTSCheck", ssi_getStaRTSCheck},
   	{"getStaFragmentCheck", ssi_getStaFragmentCheck},
   	{"getStaRTS", ssi_getStaRTS},
   	{"getStaFragment", ssi_getStaFragment},
   	//{"getStaAdhocMode", ssi_getStaAdhocMode},
   	{"getStaChannel", ssi_getStaChannel},
   	{"getStaPremableType", ssi_getStaPremableType},
   	{"getStaAuth", ssi_getStaAuth},
   	{"getStaEncryp", ssi_getStaEncryp},
   	{"getStaKey1", ssi_getStaKey1},
   	{"getStaKey2", ssi_getStaKey2},
   	{"getStaKey3", ssi_getStaKey3},
   	{"getStaKey4", ssi_getStaKey4},
   	{"getStaKey1Type", ssi_getStaKey1Type},
   	{"getStaKey2Type", ssi_getStaKey2Type},
   	{"getStaKey3Type", ssi_getStaKey3Type},
   	{"getStaKey4Type", ssi_getStaKey4Type},
   	{"getStaKey1Length", ssi_getStaKey1Length},
   	{"getStaKey2Length", ssi_getStaKey2Length},
   	{"getStaKey3Length", ssi_getStaKey3Length},
   	{"getStaKey4Length", ssi_getStaKey4Length},
   	{"getStaKeyDefaultID", ssi_getStaKeyDefaultID},
   	{"getStaWPAPSK", ssi_getStaWPAPSK},
	{"getStaConnectionSSID", ssi_getStaConnectionSSID},
   	{"getStaBSSIDScanList", ssi_getStaBSSIDScanList},
	{"refreshStaSiteSurvey", ssi_refreshStaSiteSurvey},
	{"refreshStaProfile", ssi_refreshStaProfile},
	{"getStaSupportAMode", ssi_getStaSupportAMode},
	{"getStaWirelessMode", ssi_getStaWirelessMode},
	{"getStaCountryRegionA", ssi_getStaCountryRegionA},
	{"getStaCountryRegionBG", ssi_getStaCountryRegionBG},
	{"getStaBGProtection", ssi_getStaBGProtection},
	{"getStaTxRate", ssi_getStaTxRate},
	{"getStaTxBurst", ssi_getStaTxBurst},
	{"getStaShortSlotTime", ssi_getStaShortSlotTime},
	{"getStaRadioStatus", ssi_getStaRadioStatus},
	{"getStaStatisicsTx", ssi_getStaStatisicsTx},
	{"getStaStatisicsRxOk", ssi_getStaStatisicsRxOk},
	{"getStaStatisicsRxNoBuf", ssi_getStaStatisicsRxNoBuf},
	{"getStaStatisicsRxCRCError", ssi_getStaStatisicsRxCRCError},
	{"getStaStatisicsRxDuplication", ssi_getStaStatisicsRxDuplication},
	{"getStaLinkStatus", ssi_getStaLinkStatus},
	{"getStaConnectionStatusForLinkStatus", ssi_getStaConnectionStatusForLinkStatus},
	{"getStaExtraInfo", ssi_getStaExtraInfo},
	{"getStaLinkChannel", ssi_getStaLinkChannel},
	{"getStaLinkTxRate", ssi_getStaLinkTxRate},
   	{"getStaLinkRxRate", ssi_getStaLinkRxRate},
	{"getStaTxThroughput", ssi_getStaTxThroughput},
	{"getStaRxThroughput", ssi_getStaRxThroughput},
	{"getStaLinkQuality", ssi_getStaLinkQuality},
	{"getStaSignalStrength", ssi_getStaSignalStrength},
	{"getStaSignalStrength_1", ssi_getStaSignalStrength_1},
#ifdef PHY_N_SUPPORT
	{"getStaSignalStrength_2", ssi_getStaSignalStrength_2},
	{"getStaHT", ssi_getStaHT},
	{"getStaSNR0", ssi_getStaSNR0},
	{"getStaSNR1", ssi_getStaSNR1},
#endif	
	{"getStadBmisCheck", ssi_getStadBmisCheck},
	{"getStaDriverVersion", ssi_getStaDriverVersion},
	{"getStaUIVersion", ssi_getStaUIVersion},
	{"getStaEEPROMVersion", ssi_getStaEEPROMVersion},
	{"getStaFirmwareVersion", ssi_getStaFirmwareVersion},
	{"getStaMacAddress", ssi_getStaMacAddress},
#ifdef QOS_DLS_SUPPORT	
	{"getStaWMMEnable", ssi_getStaWMMEnable},
	{"getStaAPSDEnable", ssi_getStaAPSDEnable},
	{"getStaDLSEnable",ssi_getStaDLSEnable},
	{"getStaPSACBK", ssi_getStaPSACBK},
	{"getStaPSACBE", ssi_getStaPSACBE},
	{"getStaPSACVO", ssi_getStaPSACVO},
	{"getStaPSACVI", ssi_getStaPSACVI},
	{"getStaDlsList", ssi_getStaDlsList},
#endif
#ifdef STA_EXTEND_SUPPORT	
	{"getStaBAEnable", ssi_getStaBAEnable},
	{"getStaBAAuto", ssi_getStaBAAuto},
	{"getStaBADesity", ssi_getStaBADesity},
	{"getStaOriBATable", ssi_getStaOriBATable},
	{"getStaRecBATable", ssi_getStaRecBATable},
	{"getStaConnectedBSSID", ssi_getStaConnectedBSSID},
	{"refreshSta11nConfiguration", ssi_refreshSta11nConfiguration},
	{"setRefreshSta11nConfiguration", ssi_setRefreshSta11nConfiguration},
#endif	
#ifdef PHY_N_SUPPORT	
	{"getHTMode", ssi_getHTMode},
	{"getHTBandWidth", ssi_getHTBandWidth},
	{"getHTGI", ssi_getHTGI},
	{"getHTMCS", ssi_getHTMCS},
#endif	
	

	//802.1x
	{"getSta8021xKeyMgmt", ssi_getSta8021xKeyMgmt},
	{"getSta8021xEAP", ssi_getSta8021xEAP},
	{"getSta8021xIdentity", ssi_getSta8021xIdentity},
	{"getSta8021xCACert", ssi_getSta8021xCACert},
	{"getSta8021xClientCert", ssi_getSta8021xClientCert},
	{"getSta8021xPrivateKey", ssi_getSta8021xPrivateKey},
	{"getSta8021xPrivateKeyPassword", ssi_getSta8021xPrivateKeyPassword},
	{"getSta8021xPassword", ssi_getSta8021xPassword},
	{"getSta8021xTunnel", ssi_getSta8021xTunnel},

	{"getStaDeviceCard", ssi_getStaDeviceCard},
	

	{"getStaDeviceName", ssi_getStaDeviceName},
	{"getStaDeviceCardIndex", ssi_getStaDeviceCardIndex},
	{"getStaDHCPFlag", ssi_getStaDHCPFlag},
	{"getStaIP", ssi_getStaIP},
	{"getStaNetMask", ssi_getStaNetMask},

	{"getStaInterfaceInfo", ssi_getStaInterfaceInfo},
	// for framework
	{"getStaSupportExtChannel", ssi_getStaSupportExtChannel},
	{"getStaCountryCode", ssi_getStaCountryCode},
	{"getStaChannelGeography", ssi_getStaChannelGeography},
	{"getStaChannelList", ssi_getStaChannelList},
	{"getStaInfraMode", ssi_getStaInfraMode},
	{"getStaCloseWindowsFlag", ssi_getStaCloseWindowsFlag},
    /* Array MUST be terminated by empty entry */
    {"",         NULL}
};

//-------------------------------------------------------------------------

/* for 'ssi_dumpleases()' function */
#define REMAINING 0
#define ABSOLUTE 1

struct lease_t {
	unsigned char chaddr[16];
	u_int32_t yiaddr;
	u_int32_t expires;
};
//-------------------------------------------------------------------------

/* for Routing */
#define MAX_STATIC_ROUTE 8

/* for 'ssi_dumproute()' function */
#define RTF_UP          0x0001    /* route usable                */
#define RTF_REJECT      0x0200    /* Reject route                */
#define RTF_GATEWAY     0x0002    /* destination is a gateway    */
#define RTF_HOST        0x0004    /* host entry (net otherwise)  */
#define RTF_REINSTATE   0x0008    /* reinstate route after tmout */
#define RTF_DYNAMIC     0x0010    /* created dyn. (by redirect)  */
#define RTF_MODIFIED    0x0020    /* modified dyn. (by redirect) */

/* the temporary storage path for firmware upload*/
#define IMAGE_UPLOAD "/var/image"
/* the limit of maximum file size for firmware upload*/
#define IMAGE_MAX_LEN 4000000 //4MBytes
/* the limit of minimum free memory for firmware upload*/
#define IMAGE_FREE_MEM 1500 //(KB)

/* the temporary storage path for user's config file upload*/
#define CONF_UPLOAD "/tmp/conf.gdbm"
/* the limit of maximum file size for user's config file upload*/
#define CONF_MAX_LEN 50000 //50KBytes
/* the initialized CRC for checking user's config file*/
#define CONF_CRC_INIT 0x0
//-------------------------------------------------------------------------

/* the limit of maximum wireless site survey entries*/
#define WLAN_MAX_SITE 50
/* the limit of maximum wireless association list entries*/
#define WLAN_MAX_ASSO 32
//-------------------------------------------------------------------------
