#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "nvram.h"
#include <linux/version.h>

int main(int argc,char **argv)
{
	FILE *wlanconf, *tmpconf;
	char *wordlist=NULL;
	char tmpbuf[76], tmp, tmp_sys_buf[100], tmp_rm_sys_buf[100], tmpmac[8], tmpdat[64];
	int len=0, filelen=0, dev_idx, multicard_support=0;

	memset(tmp_sys_buf, 0x00, sizeof(tmp_sys_buf));
	memset(tmp_rm_sys_buf, 0x00, sizeof(tmp_rm_sys_buf));
	memset(tmpbuf, 0x00, sizeof(tmpbuf));
	memset(tmpmac, 0x00, sizeof(tmpmac));
	memset(tmpdat, 0x00, sizeof(tmpdat));


	wordlist = nvram_get("staMultiCardSupport");
	if (wordlist == NULL)
		multicard_support = 0;
	else
		multicard_support = atoi(wordlist);
	
	if ( multicard_support )
	{
	
		//open RT28xxCard.dat
		sprintf(tmpbuf, "%s%sCard.dat", DAT_PATH, MODULE_NAME);
		tmpconf = fopen(tmpbuf, "r+");
		if (tmpconf == NULL)
		{
		    fprintf(stderr, "Can't open %s\n", tmpbuf);
			return 0;
		}

		wordlist = nvram_get("staMultiCardIdx");
		dev_idx = atoi(wordlist);
		sprintf(tmpmac, "%02xMAC", dev_idx);
		while (fscanf(tmpconf, "%s", (char *)&tmpbuf) != EOF)
		{
			if(strstr(tmpbuf, tmpmac) != NULL)
			{
				wordlist = strstr(tmpbuf, "=");
				strcpy(tmpdat, ++wordlist);  // ++wordlist , move back a character for "="
				break;
			}
		}
		fclose(tmpconf);
	}
	else
		sprintf(tmpdat, "%s%s.dat", DAT_PATH, MODULE_NAME);

	//printf("make_config -- DAT_NAME=%s\n", tmpdat);

	//sprintf(tmp_rm_sys_buf, "rm -rf %s", tmpdat);
	//sprintf(tmp_sys_buf, "mv %s%s.tmp %s", DAT_PATH, MODULE_NAME, tmpdat);

	wlanconf = fopen(tmpdat, "r+");
	if( wlanconf == NULL)
	{
	    fprintf(stderr, "Can't open %s\n", tmpdat);
		return 0;
	}
	fseek(wlanconf, 0L, SEEK_SET);
	
	tmpconf = fopen(TMP_DAT_NAME, "w+");
	if( tmpconf == NULL)
	{
	    fprintf(stderr, "Can't open %s\n", DAT_NAME);
		return 0;
	}
	fseek(tmpconf, 0L, SEEK_SET);
	

#ifdef RT61AP
    nvram_set("SystemName","RalinkAP");
    //wlanconf = fopen("/etc/Wireless/RT61AP/RT61AP.dat", "w+");
    
    fprintf(wlanconf, "#The word of \"Default\" must not be removed\n");
    fprintf(wlanconf, "Default\n");
    //CountryRegion
    wordlist = nvram_get("CountryRegion");
    fprintf(wlanconf, "CountryRegion=%d\n", atoi(wordlist));
    //CountryRegion for A band
    wordlist = nvram_get("CountryRegionABand");
    fprintf(wlanconf, "CountryRegionABand=%d\n", atoi(wordlist));
    //CountryCode
    if (strcmp(nvram_get("CountryCode"), "") == 0)
       fprintf(wlanconf, "CountryCode=\n");
    else
       fprintf(wlanconf, "CountryCode=%s\n", nvram_get("CountryCode"));
    //SSID Num. [MSSID Only]
    wordlist = nvram_get("SSIDNum");
    fprintf(wlanconf, "BssidNum=%d\n", atoi(wordlist));
    //SSID
    fprintf(wlanconf, "SSID=%s\n", nvram_get("SSID"));
    //Network Mode
    wordlist = nvram_get("WirelessMode");
    fprintf(wlanconf, "WirelessMode=%d\n", atoi(wordlist));
    //TxRate(FixedRate)
    fprintf(wlanconf, "TxRate=%s\n", nvram_get("TxRate"));
    //Channel
    wordlist = nvram_get("Channel");
    fprintf(wlanconf, "Channel=%d\n", atoi(wordlist));
    //BasicRate
    wordlist = nvram_get("BasicRate");
    fprintf(wlanconf, "BasicRate=%d\n", atoi(wordlist));
    //BeaconPeriod
    wordlist = nvram_get("BeaconPeriod");
    fprintf(wlanconf, "BeaconPeriod=%d\n", atoi(wordlist));
    //DTIM Period
    wordlist = nvram_get("DtimPeriod");
    fprintf(wlanconf, "DtimPeriod=%d\n", atoi(wordlist));
    //TxPower
    wordlist = nvram_get("TxPower");
    fprintf(wlanconf, "TxPower=%d\n", atoi(wordlist));
    //DisableOLBC
    wordlist = nvram_get("DisableOLBC");
    fprintf(wlanconf, "DisableOLBC=%d\n", atoi(wordlist));
    //BGProtection
    wordlist = nvram_get("BGProtection");
    fprintf(wlanconf, "BGProtection=%d\n", atoi(wordlist));
    //TxAntenna
    fprintf(wlanconf, "TxAntenna=\n");
    //wordlist = nvram_get("TxAntenna");
    //fprintf(wlanconf, "TxAntenna=%d\n", atoi(wordlist));
    //RxAntenna
    fprintf(wlanconf, "RxAntenna=\n");
    //wordlist = nvram_get("RxAntenna");
    //fprintf(wlanconf, "RxAntenna=%d\n", atoi(wordlist));
    //TxPreamble
    wordlist = nvram_get("TxPreamble");
    fprintf(wlanconf, "TxPreamble=%d\n", atoi(wordlist));
    //RTSThreshold  Default=2347
    wordlist = nvram_get("RTSThreshold");
    fprintf(wlanconf, "RTSThreshold=%d\n", atoi(wordlist));
    //FragThreshold  Default=2346
    wordlist = nvram_get("FragThreshold");
    fprintf(wlanconf, "FragThreshold=%d\n", atoi(wordlist));
    //TxBurst
    wordlist = nvram_get("TxBurst");
    fprintf(wlanconf, "TxBurst=%d\n", atoi(wordlist));
    //PktAggregate
    wordlist = nvram_get("PktAggregate");
    fprintf(wlanconf, "PktAggregate=%d\n", atoi(wordlist));
    //TurboRate
    //wordlist = nvram_get("TurboRate");
    fprintf(wlanconf, "TurboRate=0\n");
    //WmmCapable
    wordlist = nvram_get("WmmCapable");
    fprintf(wlanconf, "WmmCapable=%d\n", atoi(wordlist));
    //APAifsn
    fprintf(wlanconf, "APAifsn=%s\n", nvram_get("APAifsn"));
    //APCwmin
    fprintf(wlanconf, "APCwmin=%s\n", nvram_get("APCwmin"));
    //APCwmax
    fprintf(wlanconf, "APCwmax=%s\n", nvram_get("APCwmax"));
    //APTxop
    fprintf(wlanconf, "APTxop=%s\n", nvram_get("APTxop"));
    //APACM
    fprintf(wlanconf, "APACM=%s\n", nvram_get("APACM"));
    //BSSAifsn
    fprintf(wlanconf, "BSSAifsn=%s\n", nvram_get("BSSAifsn"));
    //BSSCwmin
    fprintf(wlanconf, "BSSCwmin=%s\n", nvram_get("BSSCwmin"));
    //BSSCwmax
    fprintf(wlanconf, "BSSCwmax=%s\n", nvram_get("BSSCwmax"));
    //BSSTxop
    fprintf(wlanconf, "BSSTxop=%s\n", nvram_get("BSSTxop"));
    //BSSACM
    fprintf(wlanconf, "BSSACM=%s\n", nvram_get("BSSACM"));
    //AckPolicy
    fprintf(wlanconf, "AckPolicy=%s\n", nvram_get("AckPolicy"));
    //NoForwarding pre SSID
    fprintf(wlanconf, "NoForwarding=%s\n", nvram_get("NoForwarding"));
    //NoForwardingBTNBSSID
    wordlist = nvram_get("NoForwardingBTNBSSID");
    fprintf(wlanconf, "NoForwardingBTNBSSID=%d\n", atoi(wordlist));
    //HideSSID
    fprintf(wlanconf, "HideSSID=%s\n", nvram_get("HideSSID"));
    //ShortSlot
    wordlist = nvram_get("ShortSlot");
    fprintf(wlanconf, "ShortSlot=%d\n", atoi(wordlist));
    //AutoChannelSelect
    wordlist = nvram_get("AutoChannelSelect");
    fprintf(wlanconf, "AutoChannelSelect=%d\n", atoi(wordlist));
    //IEEE8021X
    fprintf(wlanconf, "IEEE8021X=%s\n", nvram_get("IEEE8021X"));
    //IEEE80211H
    wordlist = nvram_get("IEEE80211H");
    fprintf(wlanconf, "IEEE80211H=%d\n", atoi(wordlist));
    //CSPeriod
    fprintf(wlanconf, "CSPeriod=6\n");
    //PreAuth
    fprintf(wlanconf, "PreAuth=%s\n", nvram_get("PreAuth"));
    //AuthMode
    fprintf(wlanconf, "AuthMode=%s\n", nvram_get("AuthMode"));
    //EncrypType
    fprintf(wlanconf, "EncrypType=%s\n", nvram_get("EncrypType"));
    //RekeyInterval
    wordlist = nvram_get("RekeyInterval");
    fprintf(wlanconf, "RekeyInterval=%d\n", atoi(wordlist));
    //RekeyMethod
    fprintf(wlanconf, "RekeyMethod=%s\n", nvram_get("RekeyMethod"));
    //PMKCachePeriod
    wordlist = nvram_get("PMKCachePeriod");
    fprintf(wlanconf, "PMKCachePeriod=%d\n", atoi(wordlist));
    //WPAPSK
    fprintf(wlanconf, "WPAPSK=%s\n", nvram_get("WPAPSK"));
    //DefaultKeyID
    fprintf(wlanconf, "DefaultKeyID=%s\n", nvram_get("DefaultKeyID"));
    //Key1Type(0 -> Hex, 1->Ascii)
    fprintf(wlanconf, "Key1Type=%s\n", nvram_get("Key1Type"));
    //Key1Str
    fprintf(wlanconf, "Key1Str=%s\n", nvram_get("Key1Str"));
    //Key2Type
    fprintf(wlanconf, "Key2Type=%s\n", nvram_get("Key2Type"));
    //Key2Str
    fprintf(wlanconf, "Key2Str=%s\n", nvram_get("Key2Str"));
    //Key3Type
    fprintf(wlanconf, "Key3Type=%s\n", nvram_get("Key3Type"));
    //Key3Str
    fprintf(wlanconf, "Key3Str=%s\n", nvram_get("Key3Str"));
    //Key4Type
    fprintf(wlanconf, "Key4Type=%s\n", nvram_get("Key4Type"));
    //Key4Str
    fprintf(wlanconf, "Key4Str=%s\n", nvram_get("Key4Str"));
    //HSCounter
    wordlist = nvram_get("HSCounter");
    fprintf(wlanconf, "HSCounter=%d\n", atoi(wordlist));
    //AccessPolicy0
    wordlist = nvram_get("AccessPolicy0");
    fprintf(wlanconf, "AccessPolicy0=%d\n", atoi(wordlist));
    //AccessControlLis0t
    fprintf(wlanconf, "AccessControlList0=%s\n", nvram_get("AccessControlList0"));
    //AccessPolicy1
    wordlist = nvram_get("AccessPolicy1");
    fprintf(wlanconf, "AccessPolicy1=%d\n", atoi(wordlist));
    //AccessControlList1
    fprintf(wlanconf, "AccessControlList1=%s\n", nvram_get("AccessControlList1"));
    //AccessPolicy2
    wordlist = nvram_get("AccessPolicy2");
    fprintf(wlanconf, "AccessPolicy2=%d\n", atoi(wordlist));
    //AccessControlList2
    fprintf(wlanconf, "AccessControlList2=%s\n", nvram_get("AccessControlList2"));
    //AccessPolicy3
    wordlist = nvram_get("AccessPolicy3");
    fprintf(wlanconf, "AccessPolicy3=%d\n", atoi(wordlist));
    //AccessControlList3
    fprintf(wlanconf, "AccessControlList3=%s\n", nvram_get("AccessControlList3"));
    //WdsEnable
    wordlist = nvram_get("WdsEnable");
    fprintf(wlanconf, "WdsEnable=%d\n", atoi(wordlist));
    //WdsEncrypType
    wordlist = nvram_get("WdsEncrypType");
    fprintf(wlanconf, "WdsEncrypType=%s\n", wordlist);
    //WdsList
    fprintf(wlanconf, "WdsList=%s\n", nvram_get("WdsList"));
    //WdsKey
    fprintf(wlanconf, "WdsKey=%s\n", nvram_get("WdsKey"));
    //RADIUS_Server
    fprintf(wlanconf, "RADIUS_Server=%s\n", nvram_get("RADIUS_Server"));
    //RADIUS_Port
    wordlist = nvram_get("RADIUS_Port");
    fprintf(wlanconf, "RADIUS_Port=%d\n", atoi(wordlist));
    //RADIUS_Key
    fprintf(wlanconf, "RADIUS_Key=%s\n", nvram_get("RADIUS_Key"));
    //RADIUS_Acct_Server
    fprintf(wlanconf, "RADIUS_Acct_Server=%s\n", nvram_get("RADIUS_Acct_Server"));
    //RADIUS_Acct_Port
    wordlist = nvram_get("RADIUS_Acct_Port");
    fprintf(wlanconf, "RADIUS_Acct_Port=%d\n", atoi(wordlist));
    //RADIUS_Acct_Key
    fprintf(wlanconf, "RADIUS_Acct_Key=%s\n", nvram_get("RADIUS_Acct_Key"));
    //own_ip_addr
    fprintf(wlanconf, "own_ip_addr=%s\n", nvram_get("own_ip_addr"));
    //Ethifname
    fprintf(wlanconf, "Ethifname=%s\n", nvram_get("Ethifname"));
    //session_timeout_interval
    wordlist = nvram_get("session_timeout_interval");
    fprintf(wlanconf, "session_timeout_interval=%d\n", atoi(wordlist));
    //idle_timeout_interval
    wordlist = nvram_get("idle_timeout_interval");
    fprintf(wlanconf, "idle_timeout_interval=%d\n", atoi(wordlist));
    
#else

//#ifdef RT2860STA

	nvram_set("SystemName","RalinkSTA");
	//fprintf(wlanconf, "#The word of \"Default\" must not be removed\n");
    //fprintf(wlanconf, "Default\n");
	memset(tmpbuf, 0x00, sizeof(tmpbuf));

	while (fscanf(wlanconf, "%c", &tmp) != EOF)
	{
		//printf("%c %d ", tmp, tmp);
		//printf("tmpbuf=%s\n", tmpbuf);
		//find header section.
		if (filelen < 51)
		{
			fprintf(tmpconf, "%c", tmp);
			filelen++;
		}		
		else if(tmp != 0x3D) // =
		{
			tmpbuf[len++]= tmp;
		}
		else if(tmp == 0x3D)
		{
			//int wordlistlen=0;
			int aetype=0; // auth, encryp
			
			//printf("0--tmpbuf=%s\n", tmpbuf);
			if(strcmp(tmpbuf, "CountryRegion") == 0)
			{
				wordlist = nvram_get("staCountryRegionBG");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "CountryRegionABand") == 0)
			{
				wordlist = nvram_get("staCountryRegionA");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;

			}
			else if(strcmp(tmpbuf, "NetworkType") == 0)
			{
				wordlist = nvram_get("staConnectedNetworkType");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"Infra\n");
				}
				else
				{
					char networktype;
					networktype = atoi(wordlist);

					if (networktype == 0)
						sprintf(&tmpbuf[len],"Adhoc\n");
					else
						sprintf(&tmpbuf[len],"Infra\n");
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}			
			else if(strcmp(tmpbuf, "WirelessMode") == 0)
			{
				wordlist = nvram_get("staWirelessMode");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "TxRate") == 0)
			{
				wordlist = nvram_get("staTxRate");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "BGProtection") == 0)
			{
				wordlist = nvram_get("staBGProtection");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "TxBurst") == 0)
			{
				wordlist = nvram_get("staTxBurst");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "HT_OpMode") == 0)
			{
				wordlist = nvram_get("staHT_OpMode");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "HT_BW") == 0)
			{
				wordlist = nvram_get("staHT_BW");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "HT_GI") == 0)
			{
				wordlist = nvram_get("staHT_GI");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "HT_MCS") == 0)
			{
				wordlist = nvram_get("staHT_MCS");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)  // staHT_MCS is the least , so 
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			//wps, connected
			else if(strcmp(tmpbuf, "RTSThreshold") == 0)
			{
				wordlist = nvram_get("staConnectedRTS");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}				
			else if(strcmp(tmpbuf, "FragThreshold") == 0)
			{
				wordlist = nvram_get("staConnectedFrag");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "SSID") == 0)
			{
				wordlist = nvram_get("staConnectedSSID");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "AuthMode") == 0)
			{
				wordlist = nvram_get("staConnectedAuth");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"OPEN\n");
				}
				else
				{
					aetype = atoi(wordlist);
					switch(aetype)
						{
							case 0x00: //open
								strcpy(wordlist, "OPEN");
								break;
							case 0x04: //wpapsk
								strcpy(wordlist, "WPAPSK");
								break;
							case 0x01: //SHARED
								strcpy(wordlist, "SHARED");
								break;
							case 0x03: //WPA
								strcpy(wordlist, "WPA");
								break;
							case 0x06: //WPA2
								strcpy(wordlist, "WPA2");
								break;
							case 0x07: //WPA2PSK
								strcpy(wordlist, "WPA2PSK");
								break;
							case 0x05: //WPANONE
								strcpy(wordlist, "WPANONE");
								break;
							default:
								strcpy(wordlist, "OPEN");
								break;
						}

					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "EncrypType") == 0)
			{
				wordlist = nvram_get("staConnectedEncryp");
				tmpbuf[len++] = tmp;
				if(strcmp(wordlist,"") == 0 || wordlist == NULL)
				{
					sprintf(&tmpbuf[len],"NONE\n");					
				}
				else
				{
					aetype = atoi(wordlist);
					fprintf(stderr, "staConnectedEncryp aetype=%d\n", aetype);
					switch(aetype)
						{
							case 0x01: //none
								strcpy(wordlist, "NONE");
								break;
							case 0x00: //WEP
								strcpy(wordlist, "WEP");
								break;
							case 0x04: //TKIP
								strcpy(wordlist, "TKIP");
								break;
							case 0x06: //AES
								strcpy(wordlist, "AES");
								break;
							default:
								strcpy(wordlist, "NONE");
								break;
						}

					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key1Type") == 0)
			{
				wordlist = nvram_get("staConnectedKey1Type");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key1Str") == 0)
			{
				wordlist = nvram_get("staConnectedKey1Str");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key2Type") == 0)
			{
				wordlist = nvram_get("staConnectedKey2Type");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key2Str") == 0)
			{
				wordlist = nvram_get("staConnectedKey2Str");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key3Type") == 0)
			{
				wordlist = nvram_get("staConnectedKey3Type");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key3Str") == 0)
			{
				wordlist = nvram_get("staConnectedKey3Str");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key4Type") == 0)
			{
				wordlist = nvram_get("staConnectedKey4Type");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key4Str") == 0)
			{
				wordlist = nvram_get("staConnectedKey4Str");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "DefaultKeyID") == 0)
			{
				wordlist = nvram_get("staConnectedDefaultKeyId");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"1\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "WPAPSK") == 0)
			{
				wordlist = nvram_get("staConnectedWpaPsk");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}

				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}

			// for framework
			else if(strcmp(tmpbuf, "CountryCode") == 0)
			{
				wordlist = nvram_get("staCountryCode");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}

				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "ChannelGeography") == 0)
			{
				wordlist = nvram_get("staChannelGeography");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}

				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			


			else
			{
				tmpbuf[len++] = tmp;
				while (tmp != 0x0A ){
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;

					tmpbuf[len++] = tmp;
				}
			}
			fprintf(tmpconf, "%s", tmpbuf);
			memset(tmpbuf, 0x00, sizeof(tmpbuf));
			len=0;

		}
	}

	{
		int cid;

		sprintf(tmp_sys_buf, "%s%s.tmp", DAT_PATH, MODULE_NAME);

		cid = fork();
		switch (cid) {
	    case -1:
	        /* error */
	        perror("fork");
	        exit(1); //EXIT_FAILURE
	    case 0:
	        /* child, success */
		execl("/bin/mv", "mv", tmp_sys_buf, tmpdat, (void *) NULL );
	    default:
	        /* parent, success */
	        break;
		}
    }

#endif
    fclose(wlanconf);
	fclose(tmpconf);
	return 1;
}	
