#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "nvram.h"

int main(int argc,char **argv)
{
   char *wordlist = NULL;
   char wlanbuf[128] = {0};
   char wan_ip[16] = {0};
   char wan_mask[16] = {0};
   int  ret = 0;

   nvram_init();

   wordlist = nvram_get("wanConnectionMode");

   if (strcmp(wordlist, "BRIDGE") == 0) {

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl addbr br0");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl setfd br0 1");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl addif br0 eth0");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig eth0 0.0.0.0");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl addif br0 eth1");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig eth1 0.0.0.0");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      wordlist = nvram_get("lan_ipaddr");
      if (wordlist == NULL)
         strcpy(wan_ip, "192.168.100.1");
      else if (strcmp(wordlist, "") == 0)
      	 strcpy(wan_ip, "192.168.100.1");
      else
         strcpy(wan_ip, wordlist);

      wordlist = nvram_get("lan_netmask");
      if (wordlist == NULL)
         strcpy(wan_mask, "255.255.255.0");
      else if (strcmp(wordlist, "") == 0)
         strcpy(wan_mask, "255.255.255.0");
      else
         strcpy(wan_mask, wordlist);

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig br0 %s netmask %s", wan_ip, wan_mask);
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      wordlist = nvram_get("wan_gateway");
      if (wordlist == NULL) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/sbin/route add default gw 192.168.100.254");
         ret = system(wlanbuf);
         if (ret) {
            printf("%s fail !!!!!\n", wlanbuf);
            return 0;
         }
      }
      else if (strcmp(wordlist, "") == 0) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/sbin/route add default gw 192.168.100.254");
         ret = system(wlanbuf);
         if (ret) {
            printf("%s fail !!!!!\n", wlanbuf);
            return 0;
         }
      }
      else {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/sbin/route add default gw %s", wordlist);
         ret = system(wlanbuf);
         if (ret) {
            printf("%s fail !!!!!\n", wlanbuf);
            return 0;
         }
      }
   }
   else if (strcmp(wordlist, "DHCP") == 0) {

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig eth0 0.0.0.0");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/udhcpc");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl addbr br0");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl setfd br0 1");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl addif br0 eth1");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig br0 %s netmask %s", nvram_get("lan_ipaddr"), nvram_get("lan_netmask"));
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/rc.bridge");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }
   }
   else if (strcmp(wordlist, "STATIC") == 0) {

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig eth0 0.0.0.0");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      wordlist = nvram_get("wan_ipaddr");
      if (wordlist == NULL)
         strcpy(wan_ip, "192.168.5.201");
      else if (strcmp(wordlist, "") == 0)
      	 strcpy(wan_ip, "192.168.5.201");
      else
         strcpy(wan_ip, wordlist);

      wordlist = nvram_get("wan_netmask");
      if (wordlist == NULL)
         strcpy(wan_mask, "255.255.255.0");
      else if (strcmp(wordlist, "") == 0)
         strcpy(wan_mask, "255.255.255.0");
      else
         strcpy(wan_mask, wordlist);

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig eth0 %s netmask %s", wan_ip, wan_mask);
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      wordlist = nvram_get("wan_gateway");
      if (wordlist == NULL) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/sbin/route add default gw 192.168.5.254");
         ret = system(wlanbuf);
         if (ret) {
            printf("%s fail !!!!!\n", wlanbuf);
            return 0;
         }
      }
      else if (strcmp(wordlist, "") == 0) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/sbin/route add default gw 192.168.5.254");
         ret = system(wlanbuf);
         if (ret) {
            printf("%s fail !!!!!\n", wlanbuf);
            return 0;
         }
      }
      else {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/sbin/route add default gw %s", wordlist);
         ret = system(wlanbuf);
         if (ret) {
            printf("%s fail !!!!!\n", wlanbuf);
            return 0;
         }
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl addbr br0");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl setfd br0 1");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/brctl addif br0 eth1");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig br0 %s netmask %s", nvram_get("lan_ipaddr"), nvram_get("lan_netmask"));
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/etc/rc.bridge");
      ret = system(wlanbuf);
      if (ret) {
         printf("%s fail !!!!!\n", wlanbuf);
         return 0;
      }
   }
   else if (strcmp(wordlist, "PPPOE") == 0) {
   }

   nvram_close();
}	
