#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <linux/in.h>
#include <linux/if_ether.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <linux/filter.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>
#include <stdlib.h>

struct sock_filter BPF_code[]=
{
/* ether proto 0x0800 */
{ 0x28, 0, 0, 0x0000000c },
{ 0x15, 0, 1, 0x00000816 },
{ 0x6, 0, 0, 0x00000060 },
{ 0x6, 0, 0, 0x00000000 }
};

struct sock_fprog Filter;

int main(int argc, char **argv) {
  int sock, sock2, n;
  char buffer[2048];
  unsigned char *iphead, *ethhead;
  struct ifreq ethreq;
  struct ifreq ifr;
  struct sockaddr_ll addr;

  if ( (sock=socket(PF_PACKET, SOCK_RAW,
                    htons(ETH_P_ALL)))<0) {
    perror("socket");
    exit(1);
  }

  if ( (sock2=socket(PF_PACKET, SOCK_RAW,
                    htons(ETH_P_ALL)))<0) {
    perror("socket2");
    exit(1);
  }

    memset(&ifr, 0, sizeof(ifr));

    //if your interface name is not 'eth0', then you need to modify 'Ethifname' in RT61AP.dat as what you want
    //sprintf(ifr.ifr_name, "eth%d", 0);
    memcpy(ifr.ifr_name, "eth0" , 5);

    if (ioctl(sock, SIOCGIFINDEX, &ifr) != 0)
    {
        perror("ioctl(SIOCGIFHWADDR)(eth_sock)");
        return -1;
    }

    memset(&addr, 0, sizeof(addr));
	addr.sll_family = AF_PACKET;
	addr.sll_ifindex = ifr.ifr_ifindex;
	if (bind(sock, (struct sockaddr *) &addr, sizeof(addr)) < 0)
	{
		perror("bind");
		return -1;
	}
	if (bind(sock2, (struct sockaddr *) &addr, sizeof(addr)) < 0)
	{
		perror("bind");
		return -1;
	}
  Filter.len = 4;
  Filter.filter = BPF_code;


  /* Set the network card in promiscuos mode */
  strncpy(ethreq.ifr_name,"eth0",IFNAMSIZ);
  if (ioctl(sock,SIOCGIFFLAGS,&ethreq)==-1) {
    perror("ioctl");
    close(sock);
    exit(1);
  }
  ethreq.ifr_flags|=IFF_PROMISC;
  if (ioctl(sock,SIOCSIFFLAGS,&ethreq)==-1) {
    perror("ioctl");
    close(sock);
    exit(1);
  }


#if 0
  /* Attach the filter to the socket */
  if (setsockopt(sock, SOL_SOCKET, SO_ATTACH_FILTER, &Filter, sizeof(Filter))<0) {
  	perror("setsockopt");
  	close(sock);
  	exit(1);
  }
#endif
#if 0
  /* Attach the filter to the socket */
  if (setsockopt(sock2, SOL_SOCKET, SO_ATTACH_FILTER, &Filter, sizeof(Filter))<0) {
  	perror("setsockopt");
  	close(sock);
  	exit(1);
  }
#endif
   printf("Running \n");

  while (1) {
//    printf("----------\n");
    n = recvfrom(sock,buffer,2048,0,NULL,NULL);
//    printf("%d bytes read\n",n);

    /* Check to see if the packet contains at least 
     * complete Ethernet (14), IP (20) and TCP/UDP 
     * (8) headers.
     */
    if (n<42) {
      perror("recvfrom():");
      printf("Incomplete packet (errno is %d)\n",
             errno);
      close(sock);
      exit(0);
    }

    ethhead = (unsigned char *)buffer;
#if 0
    printf("Destination MAC address: "
           "%02x:%02x:%02x:%02x:%02x:%02x\n",
           ethhead[0],ethhead[1],ethhead[2],
           ethhead[3],ethhead[4],ethhead[5]);
    printf("Source MAC address: "
           "%02x:%02x:%02x:%02x:%02x:%02x\n",
           ethhead[6],ethhead[7],ethhead[8],
           ethhead[9],ethhead[10],ethhead[11]);

	printf("Protocol: 0x%02x%02x\n", ethhead[12], ethhead[13]);
#endif
    iphead = (unsigned char *)buffer+14; /* Skip Ethernet header */
    if (*iphead==0x45) { /* Double check for IPv4
                          * and no options present */
#if 0
      printf("Source host %d.%d.%d.%d\n",
             iphead[12],iphead[13],
             iphead[14],iphead[15]);
      printf("Dest host %d.%d.%d.%d\n",
             iphead[16],iphead[17],
             iphead[18],iphead[19]);
      printf("Source,Dest ports %d,%d\n",
             (iphead[20]<<8)+iphead[21],
             (iphead[22]<<8)+iphead[23]);
      printf("Layer-4 protocol %d\n",iphead[9]);
#endif
    }
  }
  
}
